﻿Public Class Form1
	Public NumCards As Integer
	Public Cardnum As Short

	Dim Ports(5) As Integer
	Public RunFlag As Boolean
	Public Offset As Integer
	Public MyIndex As Short
	Dim MyValues(2) As Short
	Public Msg As String

	Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		Memo1.Text = "This sample outputs a walking bit on Port A of the selected group. It then reads back the value from Port A. This should be identical to the output value due to on-chip readback. It also displays the Input from Port B. If a wrap plug is installed, Port B should read the same value. Otherwise, ground individual bits on Port B to see them show zeroes on the display." & Chr(13) & Chr(10)
		Memo1.SelectionStart = 32768

		Dim found As Boolean
		Dim DeviceID As Integer
		Dim Base As Integer
		Dim NameSize As Integer
		'UPGRADE_NOTE: Name was upgraded to Name_Renamed. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Name_Renamed As String
		Dim i As Short
		Dim Status As UInt32

		NumCards = 0
		Cardnum = 0
		DeviceID = 0
		NameSize = 0
		Name_Renamed = ""

		found = False
		RunFlag = True

		'Make sure there's at least one card in the system
		NumCards = GetNumCards()
		If (NumCards = 0) Then GoTo NoCards

		'Samples are for only one card get the device ID
		Status = QueryCardInfo(i, DeviceID, Base, NameSize, Name_Renamed)
		CardName.Text = Name_Renamed

NoCards:
		If Not found Then
			CardName.Text = "No Card Found"
			Memo1.Text = "No Card Found!" & Chr(13) & Chr(10) & "This may mean that the card is not installed, or the AIOWDM driver is not working; check Device Manager" & Chr(13) & Chr(10)
			Memo1.SelectionStart = 32768

			RunFlag = False
		End If

	End Sub

	Private Sub Perform_Click(sender As Object, e As EventArgs) Handles PerformButton.Click
		If Timer1.Enabled Then
			Timer1.Enabled = False
			PerformButton.Text = "Perform I/O"
		Else
			Timer1.Enabled = True
			PerformButton.Text = "Stop I/O"
		End If
	End Sub

	Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
		Dim j As Short

		MyValues(0) = 2 ^ MyIndex
		RelOutPortB(Cardnum, 0, MyValues(0)) 'write relays

		' so this will read A and B inputs values even though A is set for output we can read/veify its value
		MyValues(2) = RelInPortB(Cardnum, Offset + 1) And &HFF ' read isolated inputs

		MyIndex = MyIndex + 1
		MyIndex = MyIndex Mod 8

		Msg = ""
		For j = 7 To 0 Step -1
			If (MyValues(0) And (2 ^ j)) > 0 Then
				Msg = Msg & "1"
			Else
				Msg = Msg & "0"
			End If
		Next
		PortAOut.Text = Msg

		Msg = ""
		For j = 7 To 0 Step -1
			If (MyValues(2) And (2 ^ j)) > 0 Then
				Msg = Msg & "1"
			Else
				Msg = Msg & "0"
			End If
		Next
		PortBIn.Text = Msg
	End Sub
End Class
